# FILE: procs.tcl
#
# Misc. Tcl support code for the mmsolve application.
#

proc SlurpImageFile { filename varname } {
    # Fills $varname with a PPM representation of the data in filename
    upvar $varname var

    # First open file directly
    set chanid [open $filename r]
    set var [read $chanid 2]
    if {![string match P3 $var]} {
        # Input file is not PPM P3 (ASCII) type.  Send through filter.
        close $chanid
        set var {}
        set shellList {wish omfsh}
        global tcl_platform
        if {[string match windows $tcl_platform(platform)]} { 
            # On Windows, only tclsh allows writing to stdout
            set shellList tclsh
        }
        foreach shell $shellList {
            if {![catch {Oc_Application Resolve $shell} h]} {
                break
            }
        }
        if {![catch {$h Class} hc] && [string match Oc_Application $hc]} {
            set shell [file join [$h Cget -directory] [$h Cget -file]]
        } else {
            return -code error "Can't find shell to convert image file\
                    $filename to PPM P3 format."
        }
        set g2pname [file join [file dirname [info nameofexecutable]] \
                .. gif2ppm.tcl]
        set chanid [open [list | $shell $g2pname -noinfo -o - $filename] r]
    }
    fconfigure $chanid -translation binary \
            -buffering full -buffersize 250000
    append var [read $chanid]
    close $chanid
}

